Index: /changelog
===================================================================
--- /changelog	(revision 7767)
+++ /changelog	(revision 7768)
@@ -392,4 +392,6 @@
 - Bugfix: Zahlungsart "Kostenlos" lÃ€sst sich im Produkt auswÃ€hlen / Task #743
 - Bugfix: DownloadPlus - Dateinamen mit Freizeichen sind jetzt mÃ¶glich / Task #744
+- Bugfix: Downloadplus - Das Font Helvetica Kursiv funktioniert wieder
+- Bugfix: Downloadplus - Speichern von Winkel und Sichtbarkeit wieder mÃ¶glich
 - Bugfix: Technische Einstellungen in Bestellung unter "Entwickleroptionen" verschoben um Verwirrungen zu vermeiden
 - Bugfix: Ist Mindestbestellmenge einzeln aktiviert erscheint es im Reiter "Bestand / Gew. / FÃŒllm." innerhalb der Produktverwaltung / Task #745
Index: /lib/FPDF_1.81/font/helveticai.php
===================================================================
--- /lib/FPDF_1.81/font/helveticai.php	(revision 7767)
+++ /lib/FPDF_1.81/font/helveticai.php	(revision 7768)
@@ -1,5 +1,5 @@
 <?php
 $type = 'Core';
-$name = 'Helvetica-Oblique';
+$name = 'Helvetica';
 $up = -100;
 $ut = 50;
Index: /lib/FPDF_1.81/fpdf.php
===================================================================
--- /lib/FPDF_1.81/fpdf.php	(revision 7767)
+++ /lib/FPDF_1.81/fpdf.php	(revision 7768)
@@ -105,4 +105,5 @@
 	if(defined('FPDF_FONTPATH'))
 	{
+
 		$this->fontpath = FPDF_FONTPATH;
 		if(substr($this->fontpath,-1)!='/' && substr($this->fontpath,-1)!='\\')
@@ -113,4 +114,6 @@
 	else
 		$this->fontpath = '';
+
+
 	// Core fonts
 	$this->CoreFonts = array('courier', 'helvetica', 'times', 'symbol', 'zapfdingbats');
@@ -447,4 +450,5 @@
 function AddFont($family, $style='', $file='')
 {
+
 	// Add a TrueType, OpenType or Type1 font
 	$family = strtolower($family);
@@ -472,4 +476,5 @@
 function SetFont($family, $style='', $size=0)
 {
+
 	// Select a font; size given in points
 	if($family=='')
@@ -499,4 +504,5 @@
 		if($family=='arial')
 			$family = 'helvetica';
+
 		if(in_array($family,$this->CoreFonts))
 		{
Index: /lib/FPDI_2.2.0/FpdfTplTrait.php
===================================================================
--- /lib/FPDI_2.2.0/FpdfTplTrait.php	(revision 7767)
+++ /lib/FPDI_2.2.0/FpdfTplTrait.php	(revision 7768)
@@ -388,10 +388,14 @@
      * @inheritdoc
      */
-    public function SetFont($family, $style = '', $size = 0)
-    {
+    public function SetFont($family, $style = '', $size = 0) {
+
         parent::SetFont($family, $style, $size);
+
         if ($this->page === 0 && $this->currentTemplateId !== null) {
+
             $this->_out(\sprintf('BT /F%d %.2F Tf ET', $this->CurrentFont['i'], $this->FontSizePt));
-        }
+
+        }
+
     }
 
Index: /lib/functions.inc.php
===================================================================
--- /lib/functions.inc.php	(revision 7767)
+++ /lib/functions.inc.php	(revision 7768)
@@ -1857,8 +1857,9 @@
 	 * Gibt einen String zurÃŒck und verhindert Fehler wenn eine Wert nicht definiert wurde
 	 */
-	function wpsg_getStr(&$value, $default = '')
-	{
-		
-		if (!isset($value) || !wpsg_isSizedString($value)) return strval($default);
+	function wpsg_getStr(&$value, $default = '') {
+
+	    $test_value = strval($value);
+
+		if (!isset($value) || !wpsg_isSizedString($test_value)) return strval($default);
 		
 		return $value;		
Index: /mods/wpsg_mod_downloadplus.class.php
===================================================================
--- /mods/wpsg_mod_downloadplus.class.php	(revision 7767)
+++ /mods/wpsg_mod_downloadplus.class.php	(revision 7768)
@@ -87,4 +87,6 @@
         $this->shop->checkDefault('wpsg_mod_downloadplus_numberformat', '%download_nr%');
         $this->shop->checkDefault('wpsg_mod_downloadplus_startnumber', '1');
+        $this->shop->checkDefault('wpsg_mod_downloadplus_autosend', '1');
+        $this->shop->checkDefault('wpsg_mod_downloadplus_indiv_mode', '1');
 
     } // public function install()
@@ -158,5 +160,5 @@
 				wpsg_checkInput($v['font'],WPSG_SANITIZE_TEXTFIELD, ['allowEmpty' => true]) 
 			) {
-    			
+
     			$arText[$k] = [
     				'x' => wpsg_getInt($v['x']),
@@ -172,5 +174,5 @@
 					'font' => wpsg_getStr($v['font'])
 				];
-    			
+
 			} else {
     			
@@ -178,9 +180,9 @@
     			
     			$this->shop->addBackendError(wpsg_translate(__('Bitte Eingaben in den Texten bei Zeile #1# prÃŒfen.', 'wpsg'), $k + 1));
-    			
+
 			}
     		
 		}
-		
+
         $this->shop->update_option('wpsg_mod_downloadplus_text', $arText, false, false, WPSG_SANITIZE_NONE);
         $this->shop->update_option('wpsg_mod_downloadplus_filename', $_REQUEST['wpsg_mod_downloadplus_filename'], false, false, WPSG_SANITIZE_TEXTFIELD);
@@ -214,6 +216,5 @@
     } // public function settings_save()
 
-    public function settings_edit()
-    {
+    public function settings_edit() {
 
         $font_path = WPSG_PATH_LIB.'FPDF_1.81/font/';
@@ -221,16 +222,13 @@
         $arFontFiles = scandir($font_path);
 
-        foreach ($arFontFiles as $k => $v)
-        {
+        foreach ($arFontFiles as $k => $v) {
 
             $file = $font_path.$v;
 
-            if (is_file($file) && file_exists($file) && preg_match('/(.*)\.php$/i', $v))
-            {
+            if (is_file($file) && file_exists($file) && preg_match('/(.*)\.php$/i', $v)) {
 
                 $this->shop->view['wpsg_mod_downloadplus']['arFonts'][$v] = ucfirst(preg_replace('/\.php$/i', '', $v));
 
             }
-
 
         }
@@ -773,5 +771,5 @@
         if ($this->shop->get_option('wpsg_mod_downloadplus_memorylimit') == '1') ini_set('memory_limit', '2000M');
         if ($this->shop->get_option('wpsg_mod_downloadplus_timelimit') == '1') set_time_limit(3600);
-	
+
 		require_once WPSG_PATH_LIB.'FPDF_1.81/fpdf.php';
 		require_once WPSG_PATH_LIB.'FPDI_2.2.0/autoload.php';