Index: /mods/wpsg_mod_abo.class.php
===================================================================
--- /mods/wpsg_mod_abo.class.php	(revision 7815)
+++ /mods/wpsg_mod_abo.class.php	(revision 7816)
@@ -237,5 +237,5 @@
 			$this->shop->update_option('wpsg_mod_abo_expiremode', $_REQUEST['wpsg_mod_abo_expiremode'], false, false, WPSG_SANITIZE_VALUES, [wpsg_mod_abo::EXPIRE_AUTO, wpsg_mod_abo::EXPIRE_MAIL]);
             
-			$this->shop->update_option('wpsg_mod_abo_autoexpire_payment', $_REQUEST['wpsg_mod_abo_autoexpire_payment'], false, false, WPSG_SANITIZE_VALUES, array_keys($this->shop->arPayment));
+			$this->shop->update_option('wpsg_mod_abo_autoexpire_payment', $_REQUEST['wpsg_mod_abo_autoexpire_payment'], false, false, WPSG_SANITIZE_VALUES, array_merge(['origin'], array_keys($this->shop->arPayment)));
 			$this->shop->update_option('wpsg_mod_abo_autoexpire_customermail', $_REQUEST['wpsg_mod_abo_autoexpire_customermail'], false, false, WPSG_SANITIZE_CHECKBOX);
 			$this->shop->update_option('wpsg_mod_abo_autoexpire_adminmail', $_REQUEST['wpsg_mod_abo_autoexpire_adminmail'], false, false, WPSG_SANITIZE_CHECKBOX);
@@ -337,6 +337,6 @@
 		        
             } else if ($_REQUEST['wpsg_mod_abo_expiremode'] === wpsg_mod_abo::EXPIRE_AUTO) {
-
-                if (wpsg_checkInput($_REQUEST['wpsg_mod_abo_autoexpire_payment'], WPSG_SANITIZE_INT)) $oProduct->setMeta('wpsg_mod_abo_autoexpire_payment', $_REQUEST['wpsg_mod_abo_autoexpire_payment']);
+                
+                if (wpsg_checkInput($_REQUEST['wpsg_mod_abo_autoexpire_payment'], WPSG_SANITIZE_VALUES, array_merge(['origin'], array_keys($this->shop->arPayment)))) $oProduct->setMeta('wpsg_mod_abo_autoexpire_payment', $_REQUEST['wpsg_mod_abo_autoexpire_payment']);
                 if (wpsg_checkInput($_REQUEST['wpsg_mod_abo_autoexpire_customermail'], WPSG_SANITIZE_VALUES, [self::CONFIG, '0', '1'])) $oProduct->setMeta('wpsg_mod_abo_autoexpire_customermail', $_REQUEST['wpsg_mod_abo_autoexpire_customermail']);
                 if (wpsg_checkInput($_REQUEST['wpsg_mod_abo_autoexpire_adminmail'], WPSG_SANITIZE_VALUES, [self::CONFIG, '0', '1'])) $oProduct->setMeta('wpsg_mod_abo_autoexpire_adminmail', $_REQUEST['wpsg_mod_abo_autoexpire_adminmail']);
@@ -717,4 +717,16 @@
 				$product_data = $this->shop->loadProduktArray($oOrderProduct->getProductId());
 
+				$payment = $this->getSetting('wpsg_mod_abo_autoexpire_payment', $oOrderProduct->getProductId());
+				
+				if ($payment === 'origin') {
+				    
+				    $_SESSION['wpsg']['checkout']['payment'] = $oOrderProduct->getOrder()->getPaymentID();
+				    
+                } else {
+
+                    $_SESSION['wpsg']['checkout']['payment'] = $payment;
+				    
+                }
+				
 				$this->shop->addFrontendMessage(wpsg_translate(__('Abo VerlÃ€ngerung fÃŒr Produkt #1# eingefÃŒgt', 'wpsg'), $product_data['name']));
 
@@ -1316,5 +1328,17 @@
  
             $_SESSION['wpsg']['checkout']['id'] = $oOrder->k_id;
-            $_SESSION['wpsg']['checkout']['payment'] = $this->getSetting('wpsg_mod_abo_autoexpire_payment', $product_id);
+
+            $payment = $this->getSetting('wpsg_mod_abo_autoexpire_payment', $product_id);
+
+            if ($payment === 'origin') {
+
+                $_SESSION['wpsg']['checkout']['payment'] = $oOrderProduct->getOrder()->getPaymentID();
+
+            } else {
+
+                $_SESSION['wpsg']['checkout']['payment'] = $payment;
+
+            }
+            
             $_SESSION['wpsg']['checkout']['shipping'] = $oOrder->type_shipping;
             
Index: /mods/wpsg_mod_userpayment.class.php
===================================================================
--- /mods/wpsg_mod_userpayment.class.php	(revision 7815)
+++ /mods/wpsg_mod_userpayment.class.php	(revision 7816)
@@ -94,6 +94,5 @@
 			{
 
-				if ($_REQUEST['field'] == 'name')
-				{
+				if ($_REQUEST['field'] == 'name') {
 
 					$_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']);
@@ -107,7 +106,5 @@
 					die(wpsg_hspc($_REQUEST['value']));
 					
-				} 
-				else if ($_REQUEST['field'] == 'hint')
-				{
+				} else if ($_REQUEST['field'] == 'hint') {
 
 					$_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']);
@@ -121,7 +118,5 @@
 					die(wpsg_hspc($_REQUEST['value']));
 					
-				}
-				else if ($_REQUEST['field'] == 'mwst_key')
-				{
+				} else if ($_REQUEST['field'] == 'mwst_key') {
 
 					$_REQUEST['value'] = wpsg_sinput("key", $_REQUEST['value']);
@@ -134,7 +129,5 @@
 					die(wpsg_hspc($tax_groups[$_REQUEST['value']]));
 					
-				}
-				else if ($_REQUEST['field'] == 'mwst_laender')
-				{
+				} else if ($_REQUEST['field'] == 'mwst_laender') {
 
 					$_REQUEST['value'] = wpsg_sinput("key", $_REQUEST['value']);
@@ -146,7 +139,5 @@
 					die();
 					
-				}
-				else if ($_REQUEST['field'] == 'rabgeb')
-				{
+				} else if ($_REQUEST['field'] == 'rabgeb') {
 
 					$_REQUEST['value'] = wpsg_tf(wpsg_sinput("key", $_REQUEST['value'], "isFloat"));
@@ -158,9 +149,7 @@
 					die(wpsg_ff($_REQUEST['value']));
 					
-				}
-				else if ($_REQUEST['field'] == 'aktiv')
-				{
-
-					$_REQUEST['value'] = wpsg_sinput("key", $_REQUEST['value']);
+				} else if ($_REQUEST['field'] == 'aktiv') {
+
+					$_REQUEST['value'] = intval($_REQUEST['value']);
 
 					$this->db->UpdateQuery(WPSG_TBL_ZV, array(
Index: /views/admin/form/select.phtml
===================================================================
--- /views/admin/form/select.phtml	(revision 7815)
+++ /views/admin/form/select.phtml	(revision 7816)
@@ -73,5 +73,5 @@
 					
 							if (wpsg_isTrue($this->view['field_config']['noKeys']) && wpsg_isSizedString($v, $this->view['field_value'])) echo ' selected="selected" ';						
-							else echo (($k == $this->view['field_value'])?'selected="selected"':'');
+							else echo ((strval($k) === strval($this->view['field_value']))?'selected="selected"':'');
 					
 						}
Index: /views/mods/mod_abo/produkt_addedit_content.phtml
===================================================================
--- /views/mods/mod_abo/produkt_addedit_content.phtml	(revision 7815)
+++ /views/mods/mod_abo/produkt_addedit_content.phtml	(revision 7816)
@@ -5,7 +5,10 @@
 	 */
 
-    $arPaymentSelect = Array();
+    $arPaymentSelect = [
+        'origin' => __('Wie ursprÃŒngliche Zahlungsart', 'wpsg')
+	];
+    
     foreach ($this->arPayment as $p) { $arPaymentSelect[$p['id']] = $p['name']; }
-	
+    
 ?>
 <script type="text/javascript">/* <![CDATA[ */
@@ -78,5 +81,5 @@
 			
 			<div class="wpsg_mod_abo_expiremode wpsg_mod_abo_expiremode_<?php echo wpsg_mod_abo::EXPIRE_AUTO; ?>" style="display:none;">
- 
+				
                 <?php echo wpsg_drawForm_Select('wpsg_mod_abo_autoexpire_payment', __('Zahlungsart fÃŒr automatische VerlÃ€ngerung', 'wpsg'), $arPaymentSelect, $this->view['product']['wpsg_mod_abo_autoexpire_payment'], array('help' => 'wpsg_mod_abo_autoexpire_payment')); ?>
                 
Index: /views/mods/mod_abo/settings_edit.phtml
===================================================================
--- /views/mods/mod_abo/settings_edit.phtml	(revision 7815)
+++ /views/mods/mod_abo/settings_edit.phtml	(revision 7816)
@@ -5,5 +5,8 @@
 	 */
 	
-	$arPaymentSelect = Array();
+	$arPaymentSelect = [
+		'origin' => __('Wie ursprÃŒngliche Zahlungsart', 'wpsg')
+	];
+	
 	foreach ($this->arPayment as $p) { $arPaymentSelect[$p['id']] = $p['name']; }
 	
Index: /views/mods/mod_userpayment/list.phtml
===================================================================
--- /views/mods/mod_userpayment/list.phtml	(revision 7815)
+++ /views/mods/mod_userpayment/list.phtml	(revision 7816)
@@ -41,5 +41,5 @@
 
 				var value = 0;
-				if (jQuery(this).attr("checked") === true) value = 1;
+				if (jQuery(this).prop("checked") === true) value = 1;
 
 				jQuery.ajax( {
@@ -106,5 +106,5 @@
 
 				var value = 0;
-				if (jQuery(this).attr("checked") == "checked") value = 1;
+				if (jQuery(this).prop("checked") === true) value = 1;
 
 				jQuery.ajax( {