Index: /mods/wpsg_mod_abo.class.php
===================================================================
--- /mods/wpsg_mod_abo.class.php	(revision 7833)
+++ /mods/wpsg_mod_abo.class.php	(revision 7834)
@@ -1325,5 +1325,5 @@
          */
 		public function autoExtendOrder($order_id, $order_product_id) {
-            
+
 		    $oOrderProduct = wpsg_order_product::getInstance($order_product_id);
             $product_id = $oOrderProduct->getProductId();
@@ -1374,8 +1374,8 @@
           
             $oBasket->addProduktToSession('abo_'.$order_id.'_'.$order_product_id, 1);
-      
+
             $oBasket->initFromSession(true); $arBasket = $oBasket->toArray();
             $new_o_id = $oBasket->save(true, false);
-         
+
             $arBasket['checkout']['knr'] = $customer_db_data['knr'];
             $arBasket['checkout']['onr'] = $this->db->fetchOne("SELECT `onr` FROM `".WPSG_TBL_ORDER."` WHERE `id` = '".wpsg_q($new_o_id)."' ");
Index: /mods/wpsg_mod_stock.class.php
===================================================================
--- /mods/wpsg_mod_stock.class.php	(revision 7833)
+++ /mods/wpsg_mod_stock.class.php	(revision 7834)
@@ -336,15 +336,13 @@
 		} // public function basket_updateProduktFromSession(&$product_key, &$stock)
 
-		public function basket_produkttosession($product_key, &$amount_set, &$ses_data)
-		{
+		public function basket_produkttosession($product_key, &$amount_set, &$ses_data) {
 
 			//$ses_amount = max(array($this->getAmountSession($product_key), $this->getAmountSessionById($this->shop->getProduktId($product_key))));
 
-			if ($this->shop->hasMod('wpsg_mod_productvariants') && $this->shop->callMod('wpsg_mod_productvariants', 'isVariantsProductKey', array($product_key)))
-			{
+			if ($this->shop->hasMod('wpsg_mod_productvariants') && $this->shop->callMod('wpsg_mod_productvariants', 'isVariantsProductKey', array($product_key))) {
 				$ses_amount = $this->getAmountSession($product_key);
-			}
-			else 
-			{
+
+			} else {
+
 				$ses_amount = $this->getAmountSessionById($this->shop->getProduktId($product_key));
 			}
@@ -352,10 +350,8 @@
 			$check_amount = $amount_set + $ses_amount;
 
- 			if (!$this->checkBestand($product_key, $check_amount))
-			{
+ 			if (!$this->checkBestand($product_key, $check_amount)) {
 
 				/* Nicht mehr ausreichend im Lager */
-				if ($this->shop->get_option('wpsg_mod_stock_allow') === '1')
-				{
+				if ($this->shop->get_option('wpsg_mod_stock_allow') === '1') {
 
 					/* Bestellungen mit negativem Lagerbestand verhindern ist aktiv */
@@ -368,7 +364,5 @@
 					if ($amount_set <= 0) return -2;
 
-				}
-				else
-				{
+				} else {
 
 					$this->shop->addFrontendError(__('Bitte beachten Sie, dass die ausgewÃ€hlte Menge den Warenbestand ÃŒberschreitet, die Bestellung jedoch abgeschlossen werden kann! Bei Fragen zur Bestellung, wenden Sie sich bitte an uns.', 'wpsg'));
@@ -570,28 +564,21 @@
 		 * @return true|false
 		 */
-		public function checkBestand($produkt_key, $menge)
-		{
-
-			if (substr($produkt_key, 0, 3) == 'abo') return;
+		public function checkBestand($produkt_key, $menge) {
 
 			$product_id = $this->shop->getProduktID($produkt_key);
 			$product_data = $this->shop->cache->loadProduct($product_id);
 
-			if ($this->shop->hasMod('wpsg_mod_productgroups'))
-			{
-
-				if (wpsg_isSizedInt($product_data['pgruppe']))
-				{
+			if ($this->shop->hasMod('wpsg_mod_productgroups')) {
+
+				if (wpsg_isSizedInt($product_data['pgruppe'])) {
 
 					$pgroup = $this->db->fetchRow("SELECT `stock_aktiv`, `stock_value` FROM `".WPSG_TBL_PRODUCTS_GROUP."` WHERE `id` = '".wpsg_q($product_data['pgruppe'])."' ");
 
-					if ($pgroup['stock_aktiv'] === '1')
-					{
+					if ($pgroup['stock_aktiv'] === '1') {
 
 						$stock = $pgroup['stock_value'];
 
 						/* Lagerbestand der Produktgruppe ist aktiv */
-						if ($menge > $stock)
-						{
+						if ($menge > $stock) {
 
 							return false;
@@ -607,6 +594,5 @@
 			$product_stock = $this->getBestand($produkt_key);
 
-			if ($menge > $product_stock)
-			{
+			if ($menge > $product_stock) {
 
 				return false;