Index: /mods/wpsg_mod_abo.class.php
===================================================================
--- /mods/wpsg_mod_abo.class.php	(revision 7835)
+++ /mods/wpsg_mod_abo.class.php	(revision 7836)
@@ -1399,15 +1399,12 @@
          * @return wpsg_order_product[]
          */
-        public function getAboProductsFromOrder($order_id)
-        {
+        public function getAboProductsFromOrder($order_id) {
             
             $oOrder = wpsg_order::getInstance($order_id);
             $arOrderProducts = Array();
             
-            foreach ($oOrder->getOrderProducts() as $oOrderProduct)
-            {
-                
-                if ($oOrderProduct->getProduct()->wpsg_mod_abo_activ)
-                {
+            foreach ($oOrder->getOrderProducts() as $oOrderProduct) {
+                
+                if ($oOrderProduct->getProduct()->wpsg_mod_abo_activ) {
                     
                     $arOrderProducts[] = $oOrderProduct;
Index: /mods/wpsg_mod_kundenverwaltung.class.php
===================================================================
--- /mods/wpsg_mod_kundenverwaltung.class.php	(revision 7835)
+++ /mods/wpsg_mod_kundenverwaltung.class.php	(revision 7836)
@@ -1152,10 +1152,8 @@
 			}
 			
-			else if (wpsg_get_the_id() == $this->shop->get_option('wpsg_page_mod_kundenverwaltung_abo') && $this->shop->hasMod('wpsg_mod_abo'))
-			{
+			else if (wpsg_get_the_id() == $this->shop->get_option('wpsg_page_mod_kundenverwaltung_abo') && $this->shop->hasMod('wpsg_mod_abo')) {
 
                 // Eingelogt
-                if ($this->isLoggedIn() > 0)
-                {
+                if ($this->isLoggedIn() > 0) {
 			    
                     $this->shop->view['arOrder'] = wpsg_order::find(Array(
@@ -1165,9 +1163,7 @@
                     
                     // Jetzt noch normale Bestellungen rausfiltern
-                    foreach ($this->shop->view['arOrder'] as $k => $oOrder)
-                    {
+                    foreach ($this->shop->view['arOrder'] as $k => $oOrder) {
                         
-                        if ($this->shop->callMod('wpsg_mod_abo', 'isAboOrder', Array($oOrder->id)) !== 1)
-                        {
+                        if ($this->shop->callMod('wpsg_mod_abo', 'isAboOrder', Array($oOrder->id)) !== 1) {
                             
                             unset($this->shop->view['arOrder'][$k]);
@@ -1179,7 +1175,5 @@
 				    $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_abo/page_abo.phtml');
 
-                }
-                else
-                {
+                } else {
 
                     $this->shop->view['error'] = $_SESSION['wpsg']['errorFields'];
Index: /views/mods/mod_abo/page_abo.phtml
===================================================================
--- /views/mods/mod_abo/page_abo.phtml	(revision 7835)
+++ /views/mods/mod_abo/page_abo.phtml	(revision 7836)
@@ -15,6 +15,103 @@
 		<div class="wpsg_mod_abo_order_product_wrap">
 		<?php foreach ($this->view['arOrder'] as $oOrder) { ?>
-		
-			<?php foreach ($this->callMod('wpsg_mod_abo', 'getAboProductsFromOrder', Array($oOrder->id)) as $oOrderProduct) { 
+
+            <?php if ($this->callMod('wpsg_mod_abo', 'isAboOrder', [$oOrder->id]) === 1) {
+
+                $arAbo = $this->callMod('wpsg_mod_abo', 'getAboProductsFromOrder', [$oOrder->id]);
+
+                foreach ($arAbo as $oOrderProduct) {
+
+                    $aboStatus = $this->callMod('wpsg_mod_abo', 'getAboProductStatus', [$oOrder->id, $oOrderProduct->id]); $oAbo = wpsg_abo::getInstance(intval($aboStatus['id']));
+                    $state = $oAbo->getState();
+
+                    ?>
+
+                    <div class="wpsg_mod_abo_order_product">
+
+                        <h1 class="entry-title title">
+                            <?php echo wpsg_translate(__('Abo "#1#" aus Bestellung #2#', 'wpsg'), $oOrderProduct->getProduct()->getProductName(), $oOrder->getNr()); ?>
+                        </h1>
+
+                        <?php $nAttachmentID = $this->imagehandler->getAttachmentID($oOrderProduct->getProductKey()); ?>
+
+                        <?php if (wpsg_isSizedInt($nAttachmentID)) { ?>
+                            <div class="image">
+                                <?php echo wp_get_attachment_image($nAttachmentID, array(100, 100), false, array()); ?>
+                            </div>
+                        <?php } ?>
+
+                        <div class="content">
+
+                            <div class="start">
+                                <span class="label"><?php echo __('Erstkauf (Startzeitpunkt):', 'wpsg'); ?></span>
+                                <span class="value">
+
+                                    <?php echo wpsg_formatTimestamp(strtotime($oOrder->cdate)); ?>
+
+                                </span>
+                            </div>
+                            <div class="price">
+                                <span class="label"><?php echo wpsg_translate(__('Preis (#1# Tage):', 'wpsg'), $oOrderProduct->getProduct()->wpsg_mod_abo_durration); ?></span>
+                                <span class="value"><?php echo wpsg_ff($oOrderProduct->getProduct()->wpsg_mod_abo_price, $this->get_option('wpsg_currency')); ?></span>
+                            </div>
+                            <div class="duration">
+                                <span class="label"><?php echo __('Laufzeit (Endzeitpunkt):', 'wpsg'); ?></span>
+                                <span class="value">
+
+                                    <?php $exp = $this->callMod('wpsg_mod_abo', 'getOrderAboExpiration', array($oOrder->id, $oOrderProduct->getId())); ?>
+
+                                    <?php if ($oAbo->getState() === wpsg_abo::STATE_RUNNING) { ?>
+                                        <span class="duration_running"><?php echo $exp; ?></span>
+                                    <?php } else if ($oAbo->getState() === wpsg_abo::STATE_INEXTENSION) { ?>
+                                        <span class="duration_inextension"><?php echo $exp; ?></span>
+                                    <?php } else if ($oAbo->getState() === wpsg_abo::STATE_EXTEND) { ?>
+                                        <span class="duration_expired"><?php echo $exp; ?></span>
+                                    <?php }  ?>
+
+                                </span>
+                            </div>
+                            <div class="status">
+                                <span class="label"><?php echo __('automatische VerlÃ€ngerung:', 'wpsg'); ?></span>
+                                <span class="value">
+
+                                    <?php if ($aboStatus['status'] === wpsg_mod_abo::STATUS_ACTIVE) { ?>
+
+                                        <span class="status_activ"><?php echo __('Aktiv'); ?></span>
+
+                                        <?php if (strtotime($aboStatus['mail_admin_stop']) > 0) { ?>
+
+                                            <?php echo __('KÃŒndigung ausstehend', 'wpsg'); ?>
+
+                                        <?php } else { ?>
+
+                                            <?php if (in_array($this->callMod('wpsg_mod_abo', 'getSetting', ['wpsg_mod_abo_autoexpire_customer', $oOrderProduct->getProductId()]), Array(wpsg_mod_abo::CUSTOMER_AUTO_MAIL, wpsg_mod_abo::CUSTOMER_AUTO_DIRECT))) { ?>
+                                            <span class="link_wrap"><a href="<?php echo $this->getUrl(wpsg_ShopController::URL_ABO, 'wpsg_mod_abo', 'stoprenewal', Array('order_id' => $oOrder->id, 'product_key' => $oOrderProduct->getProductKey())); ?>"><?php echo __('Deaktivieren'); ?></a></span>
+                                            <?php } ?>
+
+                                        <?php } ?>
+
+                                    <?php } else if ($aboStatus['status'] === wpsg_mod_abo::STATUS_STOPPED) { ?>
+                                        <span class="status_inactiv"><?php echo __('Inaktiv') ?></span>
+                                    <?php } ?>
+
+                                </span>
+                            </div>
+                        </div>
+
+                        <div class="wpsg_clear"></div>
+
+                    </div>
+
+                    <?php
+
+                }
+
+                ?>
+
+                OK
+
+            <?php } ?>
+		
+			<?php /* foreach ($this->callMod('wpsg_mod_abo', 'getAboProductsFromOrder', Array($oOrder->id)) as $oOrderProduct) {
 				
 				$product_id = $oOrderProduct->getProductId();
@@ -109,5 +206,5 @@
 				</div>
 				
-			<?php } // foreach OrderProducts ?>
+			<?php } */ ?>
 							
 		<?php } // foreach Order ?>